id: https://w3id.org/gaia-x/ONTOLOGY_VERSION/compute-function-service-offering
name: compute-function-service-offering
prefixes:
  linkml: https://w3id.org/linkml/
  gx: https://w3id.org/gaia-x/ONTOLOGY_VERSION#
  
imports:
  - linkml:types
  - service-offering
  - compute-function-configuration

default_prefix: gx
default_range: string

classes:
  ComputeFunctionServiceOffering:
    title: "Compute Function Service Offering"
    is_a: ComputeServiceOffering
    description: "A digital service available for order and providing compute functions capabilities."
    attributes:
      computeFunctionConfiguration:
        title: "Compute Function Configuration"
        description: "Attributes configurable at service instantiation."
        range: ComputeFunctionConfiguration
        required: true        
      computeFunctionDebugTools:
        title: "Compute Function Debug Tools"
        description: "Indicates whether the service includes debugging tools"
        range: boolean
      computeFunctionEditor:
        title: "Compute Function Editor"
        description: "Indicates whether the service includes a code editor."
        range: boolean
      computeFunctionAllowQuota:
        title: "Compute Function Allow Quota"
        description: "Indicates whether the service allows to define resource quotas for functions (typically memory)"
        range: boolean
      computeFunctionAllowTimeout:
        title: "Compute Function Allow Timeout"
        description: "Indicates whether the service allows to define timeouts for functions"
        range: boolean
      computeFunctionAllowVersioning:
        title: "Compute Function Allow Versioning"
        description: "Indicates whether the service allows code versioning for functions"
        range: boolean
      computeFunctionAllowAutoScaling:
        title: "Compute Function Allow Auto-scaling"
        description: "Indicates whether the service supports auto-scaling of functions"
        range: boolean
      computeFunctionAllowFSMount:
        title: "Compute Function Allow filesystem mount"
        description: "Indicates whether the service supports mounting and using external file systems in functions"
        range: boolean        
